with GNATCOM.Dispinterface;

package MSHTML.IHTMLDOMAttribute4_Interface is

   type IHTMLDOMAttribute4_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IHTMLDOMAttribute4_Type);

   function Pointer (This : IHTMLDOMAttribute4_Type)
     return Pointer_To_IHTMLDOMAttribute4;

   procedure Attach (This    : in out IHTMLDOMAttribute4_Type;
                     Pointer : in     Pointer_To_IHTMLDOMAttribute4);

   procedure Put_nodeValue
     (This : IHTMLDOMAttribute4_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_nodeValue
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.VARIANT;

   function Get_nodeName
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.BSTR;

   function Get_name
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_value
     (This : IHTMLDOMAttribute4_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True);

   function Get_value
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.BSTR;

   function Get_firstChild
     (This : IHTMLDOMAttribute4_Type)
     return Pointer_To_IHTMLDOMNode;

   function Get_lastChild
     (This : IHTMLDOMAttribute4_Type)
     return Pointer_To_IHTMLDOMNode;

   function Get_childNodes
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.Pointer_To_IDispatch;

   function hasAttributes
     (This            : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.VARIANT_BOOL;

   function hasChildNodes
     (This      : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.VARIANT_BOOL;

   procedure normalize
     (This : IHTMLDOMAttribute4_Type);

   function Get_specified
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.VARIANT_BOOL;

end MSHTML.IHTMLDOMAttribute4_Interface;

